/*     DS18B20.

 ,  2011-2012
Gennady Chernov, Dnepropetrovsk 2011-2012
 v1.04.
Microchip MPLAB XC8 C Compiler V1.12
Email: gena.chernov@gmail.com
*/

//--------------------------------------------------------------------------------------- 
//#pragma jis									//        
#include <htc.h>							//   
#include "ds18b20.h"						//
//--------------------------------------------------------------------------------------- 


//========================================================================================
//     DS18B20
//========================================================================================
//;Level_High:      -     DS18B20
void Level_HIGH (void)
{
	DALLAS=1;				//          
	__delay_us(6);			// 10         
	TRISDAL=1;				//     
}//--------------------------------------------------------------------------------------- 

//========================================================================================
// Level_LOW:     
void Level_LOW (void)
{
	DALLAS=0;				//    			
	TRISDAL=0;				//    
	__delay_us(1);			// 3   
}//---------------------------------------------------------------------------------------

//========================================================================================
// DLIT_WR:   
//  60 mks,    DS1820      .
void Waiting_WR (void)
{
	__delay_us(52);			//52   
}//---------------------------------------------------------------------------------------

//========================================================================================
//crc_bits:    crc8  DS18B20
char CRC_BITS (int data) 
{
  int i = (data ^ crc) & 0xff;
  crc = 0;
	  if(i & 0b00000001)crc ^= 0x5e;
	  if(i & 0b00000010)crc ^= 0xbc;
	  if(i & 0b00000100)crc ^= 0x61;
	  if(i & 0b00001000)crc ^= 0xc2;
	  if(i & 0b00010000)crc ^= 0x9d;
	  if(i & 0b00100000)crc ^= 0x23;
	  if(i & 0b01000000)crc ^= 0x46;
	  if(i & 0b10000000)crc ^= 0x8c;
  return crc;
}//---------------------------------------------------------------------------------------





//========================================================================================
//RESET_DALLAS:      
//  	0 -    
//				1 -      ()
//				2 -       ()
char Reset_Dallas (void)
{
char ERR_LINE; //     c
unsigned char a;
			Level_LOW();				//   >480 mks
			__delay_us(700);			// 700 mks

//   ,    
			ERR_LINE=0;//    -     c
			di();// 			

//tttt3:		di();					//  
//			if(GIE==1)goto tttt3;	//  

			Level_HIGH();				//  
		//	__delay_us(15);				// 15 mks
		//     
			a=0;
			while (ERR_LINE==0&&DALLAS==1)
			{
				CLRWDT(); 
				__delay_us(5);			// 5 mks
				if(++a>120)ERR_LINE=1; 	//   -   
			}	 
			ei();// 

		//    ,   	
			a=0;
			while (ERR_LINE==0&&DALLAS==0)
			{
				CLRWDT(); 
				__delay_us(5);			// 5 mks
				if(++a>120)ERR_LINE=2; 	//   -   
			}	 
			
			__delay_us(700);			//  >480 mks

// ,    		
			if(ERR_LINE>0)
			{
				error_con++;//  
				if(error_con<25 && TESTDT==0)ERR_LINE=0;//     
			}	
			else error_con=0;// 
			
		//	ERR_LINE=0;//test alarm
		return ERR_LINE;
}//---------------------------------------------------------------------------------------




//========================================================================================
// Dreceive:      DS18B20.
char Dreceive (void)
{
char COM_REG,a;	
	COM_REG=0;
	for (a=0; a<8; a++)						//     
	{										//
tttt0:	di();					//  
		if(GIE==1)goto tttt0;	//  
		Level_LOW ();						//      )
		Level_HIGH ();						//  
		COM_REG=COM_REG>>1;					//  +   7  0
		if (DALLAS==1)COM_REG |= 0b10000000;//   7  1  DALLAS==1
		ei();	//   
		Waiting_WR();						//     
	}
return COM_REG;
}//---------------------------------------------------------------------------------------

//========================================================================================
// Dsend:      DS1820.
void Dsend(char COM_REG) 
{
char a;
	for (a=0; a<8; a++)	
	{
tttt1:	di();					//  
		if(GIE==1)goto tttt1;	//  
		Level_LOW ();		
		if(COM_REG & 0b00000001) Level_HIGH ();
		COM_REG=COM_REG>>1;	
		ei();	//   
		Waiting_WR ();
	 	Level_HIGH ();
	}
}//---------------------------------------------------------------------------------------

//========================================================================================
/*celsio:      .   
   ,  ,      EEPROM 
 .     . 
 
NACHAD -     
COLDAT -   

// 
//  0; //     
//  1; //  
//  2; //  
//  3; //    -        
//  4; //    -    
//  5; //   
*/
char Celsio (void)
{
char a, nomdat; //   

const char con_dro[] = { 0, 1, 1, 2, 3, 3, 4, 4, 5, 6, 6, 7, 8, 8, 9, 9, 00}; 
             //         00.06.13.19.25.31.38.44.50.56.63.69.75.81.88.94.100   

int tempertura;
static bit MINUS;	

	if(CONFLAG==1)//    
	{
			if(CONV==0)	CONFLAG=0;
 		else return 2; //  
	}
	else
	{
		a=Reset_Dallas();//   
		if (a==0)
		{
			Dsend (0xCC);//    
			Dsend (0x44);//  
			CONV=1;
			CONFLAG=1;
		 	return 1; // 
		}
		else
		{
			if (a==1) return 3; //  - ,     )
			else return 4; //  -   ( )
		}
	}
//        
//----------------------------------------------------------------------
//       ,
//        
// ""   CRC/
		Reset_Dallas();//   
		Dsend (0xCC);
		Dsend(0xBE); 
		Dreceive(); 
		Dreceive();
		Dreceive();
		Dreceive();
		Dreceive();
		Dreceive();
		Dreceive();
		Dreceive();
		Dreceive();
//----------------------------------------------------------------------		
	nomdat=0;
	while (1)
	{
		//       
		//    == 028,   .
		if (EEPROM_READ((nomdat<<3)+NACHAD)!= 0x28)
		{
			coldachu=nomdat; //   
			break; //     
		}	


		if (Reset_Dallas()==0)//        
		{
			Dsend(0x55); //        
			
			//        
			EEADR=((nomdat<<3)+NACHAD);
			for (a=0;a<8;a++)
			{
				RD=1;
				Dsend(EEDATA);
				EEADR++;
			}
		}
		else
		{
			return 5; //   
		}						

//	    crc
		Dsend(0xBE); 			//   
		crc=0; 					//    			
		tempertura=Dreceive(); 	//   01
		CRC_BITS(tempertura);
		a=Dreceive(); 			//   02
		tempertura+=a<<8;		
		CRC_BITS(a);
		CRC_BITS(Dreceive()); 	//   03
		CRC_BITS(Dreceive()); 	//   04
		CRC_BITS(Dreceive()); 	//   05
		CRC_BITS(Dreceive()); 	//   06
		CRC_BITS(Dreceive()); 	//   07
		CRC_BITS(Dreceive()); 	//   08
		CRC_BITS(Dreceive()); 	//   09

//  ,      	
		if(crc!=0)		// 0=      <10
		{
			if (erroDT[nomdat]<10) erroDT[nomdat]++;	//     

			if (erroDT[nomdat]>=10||TESTDT==1)			//  10  ,   
			{
				switch (nomdat)
				{
					case 0 :
					ET00=1;
					break;
					
					case 1 :
					ET01=1;
					break;
					
					case 2 :
					ET02=1;
					break;
					
					case 3 :
					ET03=1;
					break;
					
					case 4 :
					ET04=1;
					break;
					
					case 5 :
					ET05=1;
					break;
					
					case 6 :
					ET06=1;
					break;
					
					case 7 :
					ET07=1;
					break;
					
					case 8 :
					ET08=1;
					break;
					
					case 9 :
					ET09=1;
					break;
					
					case 10 :
					ET10=1;
					break;
					
					case 11 :
					ET11=1;
					break;
					
					case 12 :
					ET12=1;
					break;
					
					case 13 :
					ET13=1;
					break;
					
					case 14 :
					ET14=1;
					break;
					
					case 15 :
					ET15=1;
					break;
				}
			}		
		}				
		else
			{
				erroDT[nomdat]=0; //   	 
				switch (nomdat)
				{
					case 0 :
					ET00=0;
					break;
					
					case 1 :
					ET01=0;
					break;
					
					case 2 :
					ET02=0;
					break;
					
					case 3 :
					ET03=0;
					break;
					
					case 4 :
					ET04=0;
					break;
					
					case 5 :
					ET05=0;
					break;
					
					case 6 :
					ET06=0;
					break;
					
					case 7 :
					ET07=0;
					break;
					
					case 8 :
					ET08=0;
					break;
					
					case 9 :
					ET09=0;
					break;
					
					case 10 :
					ET10=0;
					break;
					
					case 11 :
					ET11=0;
					break;
					
					case 12 :
					ET12=0;
					break;
					
					case 13 :
					ET13=0;
					break;
					
					case 14 :
					ET14=0;
					break;
					
					case 15 :
					ET15=0;
					break;
				}
//----------------------------------------------------------------	
//       c
				MINUS=0;
				if (tempertura & 0x8000)
				{
					tempertura=-tempertura; //  
					MINUS=1;
				}	
					a=tempertura;		//   
					a &= 0b00001111;	//   
					a=con_dro[a];		//
					
					tempertura>>=4;		//   
					tempertura=(tempertura&0x00ff)*10; // , 22,5 
					tempertura=tempertura+a;		   // 225
				
				if (MINUS==1)
				{
					tempertura=-tempertura;
				}			
				TEMPDAT[nomdat]=tempertura;
			}
		
		if(++nomdat == COLDAT)
		{
			coldachu=nomdat; 
			break; //     
		}	
	}	
	return 0;
}//---------------------------------------------------------------------------------------


//========================================================================================
/*seachROM: -     
         .
  
bayt08,bayt07,bayt06,bayt05,bayt04,bayt03,bayt02,bayt01 -    
chetchik_bit -           
tekuc_nesoot -              
posled_nesoot -          
 
0-    
1-   ,      
2-     crc
3-       
4-        ==1 ( )
 */
char SeachROM (void)
{
char chetchik_bit,tekuc_nesoot;	
static bit bA,bB;	
			
		CLRWDT(); 				//    +++++++++++++++++++++- 
		
		tekuc_nesoot=0;			//      
		
		if (Reset_Dallas()!=0)	//   
		{
			return 3; 			//       
		}	

		Dsend (0xF0); 			//    ROM			
		
		for (chetchik_bit=0;chetchik_bit<64;chetchik_bit++)
		{
			// 2   
tttt2:		di();					//  
			if(GIE==1)goto tttt2;	//  
			Level_LOW ();			//      )
			Level_HIGH ();			//  
			bA=0;
			if (DALLAS==1)bA=1; 	// 
			Waiting_WR();			//      
			
			Level_LOW ();			//      )
			Level_HIGH ();			//  
			bB=0;
			if (DALLAS==1)bB=1; 	// 
			Waiting_WR();			//      
			ei();					//    

			//  ()  ()
			if (bA && bB) 			//  ==1 -   
			{
				posled_nesoot=0; 	//    	
				return	4; 			//        ==1
 			}

			if(!bA && !bB)			//  ==0     
			{
				// ,  ""
	  			if (chetchik_bit==posled_nesoot)
				{
					bA=1; //  1
				}
				else
				{
					if (chetchik_bit>posled_nesoot)
					{
						tekuc_nesoot=chetchik_bit; //    - new current mismatch
						bA=0;  //  0
					}
					else //chetchik_bit<posled_nesoot
					{
						if (bufdt[0] & 0b00000001)
						{
							 bA=1; //  1 - set to 1
						}
						else
						{
							tekuc_nesoot=chetchik_bit;  //    - new current mismatch
							bA=0;  //  0 - set to 0	
						}
					}
				}
			}					
			//     				 	
	
			bufdt[0]>>=1;
			if (bufdt[1] & 0b00000001)bufdt[0] |= 0b10000000;
			bufdt[1]>>=1;
			if (bufdt[2] & 0b00000001)bufdt[1] |= 0b10000000;		
			bufdt[2]>>=1;
			if (bufdt[3] & 0b00000001)bufdt[2] |= 0b10000000;
			bufdt[3]>>=1;
			if (bufdt[4] & 0b00000001)bufdt[3] |= 0b10000000;
			bufdt[4]>>=1;
			if (bufdt[5] & 0b00000001)bufdt[4] |= 0b10000000;
			bufdt[5]>>=1;
			if (bufdt[6] & 0b00000001)bufdt[5] |= 0b10000000;		
			bufdt[6]>>=1;
			if (bufdt[7] & 0b00000001)bufdt[6] |= 0b10000000;
			bufdt[7]>>=1;
			if (bA==1)bufdt[7] |= 0b10000000;
	
tttt3:		di();						//  
			if(GIE==1)goto tttt3;		//  
			//    0  1     ()	
			Level_LOW(); 				// 
			if (bA) Level_HIGH(); 		//  1  
		//	else Level_LOW(); 			//   
			Waiting_WR();				//  
			Level_HIGH();				//    1
			ei();						//    
		//   64 
		}						
	 	
	 	//    
		posled_nesoot=tekuc_nesoot;
		
		//  crc  		
		crc=0; 					//    			
		CRC_BITS(bufdt[0]); 	//   01
		CRC_BITS(bufdt[1]);		//   02
		CRC_BITS(bufdt[2]); 	//   03
		CRC_BITS(bufdt[3]); 	//   04
		CRC_BITS(bufdt[4]); 	//   05
		CRC_BITS(bufdt[5]); 	//   06
		CRC_BITS(bufdt[6]); 	//   07
		CRC_BITS(bufdt[7]); 	//   08
		
		//  crc
		if (crc==0)
		{
			if (posled_nesoot == 0)
			{
				return 0; //    
			}	
				return 1; //   ,      
		}		
		return 2; //     crc

}//---------------------------------------------------------------------------------------


//========================================================================================
/* ustdate:       .
          .
 ""         
  EEPROM.
  ,  ,    0 -  .
  EEPROM    ,    
,    .    ,   
        1 -  "".
  EEPROM        ,   
            .
    2 -     .
   ,    3 -     .

 
NACHAD -     
COLDAT -   

 
0 -   
1 -  ""
2 -     
3 -     
   8 
*/
char SaveROM (void)	
{
char al,nmdt,nmdt_temp; //,   ,  	
static bit ERRO;

//     
	for (nmdt=0;nmdt<COLDAT;nmdt++) 	//       
	{	//      0x28,     	
		if (EEPROM_READ(NACHAD+(nmdt*8)) == 0x28)
		{	//       
			if ((EEPROM_READ(++EEADR)==bufdt[1])&&
				(EEPROM_READ(++EEADR)==bufdt[2])&&
				(EEPROM_READ(++EEADR)==bufdt[3]))
			{
				return 0;//         
			}
		}
		else
		{
			break;	//   
		}
	}

	ERRO=1; 		// ,    
	nmdt_temp=nmdt;	//      
	
		//    (   celsio)
		//   ,  
		//    
		//        " "
		nmdt=0;
		if(ET00==1)ET00=0;
		else
		{
			nmdt++;
			if(ET01==1)ET01=0;
			else
			{
				nmdt++;
				if(ET02==1)ET02=0;
				else
				{
					nmdt++;
					if(ET03==1)ET03=0;
					else
					{
						nmdt++;
						if(ET04==1)ET04=0;
						else
						{
							nmdt++;
							if(ET05==1)ET05=0;
							else
							{
								nmdt++;
								if(ET06==1)ET06=0;
								else
								{
									nmdt++;
									if(ET07==1)ET07=0;
									else
									{
										nmdt++;
										if(ET08==1)ET08=0;
										else
										{
											nmdt++;
											if(ET09==1)ET09=0;
											else
											{
												nmdt++;
												if(ET10==1)ET10=0;
												else
												{
													nmdt++;
													if(ET11==1)ET11=0;
													else
													{
														nmdt++;
														if(ET12==1)ET12=0;
														else
														{
															nmdt++;
															if(ET13==1)ET13=0;
															else
															{
																nmdt++;
																if(ET14==1)ET14=0;
																else
																{
																	nmdt++;
																	if(ET15==1)ET15=0;
																	else 
																	{
																		nmdt=nmdt_temp; //   .
																		ERRO=0;//     
																	}	
																}	
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
			
	//     
	if (nmdt_temp<nmdt)nmdt=nmdt_temp; //     
	//    ,   

	if ((nmdt<COLDAT))
	{
		while (WR) continue;
		for (al=0;al<8;al++)
		{	
			EEPROM_WRITE(NACHAD+(nmdt*8)+al,bufdt[al]);
			while (WR) continue;
		}
		//   
		if (ERRO)	return 1; 		//  	
		else return 2;	 			//   (     )
	}
	else  return	3; //    !! 

}//---------------------------------------------------------------------------------------				


//========================================================================================
//ERASE_EEPROM:         EEPROM.
void EraseROM (void)
{
char zec;
//         

	while (WR) continue;
	for (zec=0;zec<COLDAT;zec++)
	{
		EEPROM_WRITE(NACHAD+(zec*8),0xFF);	
		while (WR) continue;
	}					

	for (zec=0;zec<COLDAT;zec++)
	{
		TEMPDAT[zec]=0;				//     
	}
	ET00=0;
	ET01=0;
	ET02=0;
	ET03=0;
	ET04=0;
	ET05=0;
	ET06=0;
	ET07=0;
	ET08=0;
	ET09=0;
	ET10=0;
	ET11=0;
	ET12=0;
	ET13=0;
	ET14=0;
	ET15=0;
}//---------------------------------------------------------------------------------------


//========================================================================================
/*Test_DT:       
       EEPROM */
char Test_DT (void)
{
//     	
char a;
	
//	a=6;
	TESTDT=1; //     
	do //   
	{
		CLRWDT();
		a=Celsio();
	}while	(!((a==0) || (a==3) || (a==4) || (a==5)));

	if ((a==3) || (a==4) || (a==5))	return 1;
	//    

	naydendatch=0; //    
	a=1;
	while (!((a==0) || (a==2) || (a==3) || (a==4)))
	{
		a=SeachROM();		// 
		naydendatch++;		//  
		if(a==1 || a==0)
		{
		//	test=SaveROM();	//  
			SaveROM();		//  
		}	
	}	
	return 0;
}//---------------------------------------------------------------------------------------
